#!/bin/bash

# Пример скрипта, запускаемого программой PingSTAT при наступлении любых событий

# Назначаем имя log-файла
log_file=./pingstat.log

# При наступлении одного события скрипт запускается один раз. Если по одному
# пингеру наступает одновременно несколько событий, то скрипт будет запущен по
# одному разу для каждого события. Программа передает в скрипт следующие парамтры:

# Строковое значение параметра, который изменился. Возможные варианты:
# BitX - изменился бит X (X=0..7)
# MinTempError - температура опустилась ниже минимально допустимой границы
# MinTempOk - температура вернулась в допустимые пределы с нижней стороны
# MaxTempError - температура поднялась выше максимально допустимой границы
# MaxTempOk - температура вернулась в допустимые пределы с верхней стороны
# Warning - предупреждение: от пингера не получен ни один пакет в течение времени Ping_warning_timeout (задается в файое pingstat.conf)
# Dead - от пингера не получен ни один пакет в течение времени Ping_timeout (задается в файле pingstat.conf)
# Alive - возобновился поток пакетов от пингера
changed_parameter=${1} 

# Параметры пингера, по которому зафиксировано изменение:
ip=${2} 
address=${3} 
description=${4} 

# По каждому биту передается два параметра:
# Состояние бита в двоичном виде: 1 - нормальное, 0 - ненормальное (описывается в файле pingstat.conf)
bit0_bin=${5}
# Состояние бита в текстовом виде (описывается в файле pingstat.conf)
bit0_str=${6} 

bit1_bin=${7} 
bit1_str=${8} 

bit2_bin=${9} 
bit2_str=${10} 

bit3_bin=${11} 
bit3_str=${12} 

bit4_bin=${13} 
bit4_str=${14}

bit5_bin=${15} 
bit5_str=${16}

bit6_bin=${17} 
bit6_str=${18}

bit7_bin=${19} 
bit7_str=${20}

# Помещение всех входных параметров в log-файл
#echo ${1} ${2} ${3} ${4} ${5} ${6} ${7} ${8} ${9} ${10} ${11} ${12} ${13} ${14} ${15} ${16} ${17} ${18} ${19} ${20} >> $log_file

# Помещение в log-файл строки, содержащей дату, текущее время, ip пингера, адрес, измененный параметр
echo -n `date +"%Y.%m.%d %H:%M:%S" | cut -b "-19"`" - " >> $log_file
echo -n $ip $address $changed_parameter "" >> $log_file

# Анализ питания сеть/аккумулятор и добавление сообщения в log-файл
if [[ X$changed_parameter == X"Bit0" ]]
then
  if [[ X$bit0_bin == X"0" ]] #0 - ненормальное состояние, 1 - нормальное состояние
  then
      echo -n "Питание в сети пропало" >> $log_file
  else
      echo -n "Питание в сети восстановилось" >> $log_file
  fi
#else
fi

# Анализ событий Dead и Alive и отправка SMS
if [[ X$ip == X"123.123.123.123" ]]
then
  if [[ X$changed_parameter == X"Dead" ]]
  then
      ./mailer sms_dead.txt &
  fi
  if [[ X$changed_parameter == X"Alive" ]]
  then
      ./mailer sms_alive.txt &
  fi
#else
fi

echo >> $log_file